/**
 * ### Протокол и данные паблишера
 *
 * @name 01
 * @publishers
 * @memberof publishers
 */

/**
 * #### DragData - описание того, как работать с драгом из паблишера
 *
 * <br>
 *
 * #### Структура
 * ```
 * // dragType - один из типов, того что возможно перетаскивать
 * // Map(String, String) - определяет какой атрибут будет использован для получения данных
 * // короче говоря, у нас есть список колонок, которые приходят в responseTableInfo под полем tableInfo : List(VariableContainer)
 * // и там есть поле colId - это идентификатор колонки.
 * // Так вот, ключ в этой мапе и есть colId,
 * // Значением же выступает имя опции, под которым значение в поле перетаскиваемой строчки будет положено в данные клипборда
 * // в таблице ниже, приведены атрибуты соответствующие dragType'ам
 *
 * // структура
 * VariableContainer [
 *      <dragType> : Map(String, String)
 *      // <dragType> : Map(<colId>, <clipboardOptionId>)
 * ]
 *
 * // пример
 * // Здесь мы видим dragType "model"
 * // Дальше мы находим colId "modelAddr" и получаем данные из паблишера в нужной строчке по этому полю
 * // затем мы укладываем по clipboardOptionId "address" в объект клипборда значение, которое было получено из таблицы
 * // аналогичные действия проделываются и для dragType "component"
 * VariableContainer [
 *     model: Map(String, String)[
 *         "modelAddr": "address"
 *     ],
 *     component: Map(String, String)[
 *         "modelAddr": "address",
 *         "cTag": "cTag",
 *         "cid": "id"
 *     ]
 * ]
 * ```
 *
 * <br>
 *
 * #### Описание dragType'ов
 *

 *| dragType  	| description                        	| attributes                                              	|
 *|-----------	|------------------------------------	|---------------------------------------------------------	|
 *| model     	| позволяет перетаскивать устройства 	| address:Address                                         	|
 *| group     	| позволяет перетаскивать группу     	| address: Address, cTag: String                            |
 *| component 	| позволяет перетаскивать компонент  	| address: Address, cTag: String, id: String               	|
 *| attribute 	| позволяет перетаскивать атрибут    	| address: Address, cTag: String, id: String, name: String 	|
 *| node      	| позволяет перетащить ноду          	| nodeId: Integer, treeTag: String                         	|
 *
 *
 * @name 02
 * @publishers
 * @memberof publishers
 */
